export interface ISubmissionRequest {
    codeContent: string;
}
export interface ISubmissionResponse {
    result: boolean;
    url?: string;
    message?: string;
}
export declare function submit(cellContents: string): Promise<ISubmissionResponse>;
export declare function checkStatus(): Promise<void>;
/**
 * Call the API extension
 *
 * @param endPoint API REST end point for the extension
 * @param init Initial values for the request
 * @returns The response body interpreted as JSON
 */
export declare function request<T>(endPoint?: string, init?: RequestInit): Promise<T>;
